> ## Documentation Index
> Fetch the complete documentation index at: https://www.latitude.sh/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create object storage

> Creates a new object storage bucket for a project.



## OpenAPI

````yaml https://spec.speakeasy.com/latitude/latitude/latitude-sh-api-with-code-samples post /storage/objects
openapi: 3.0.1
info:
  title: Latitude.sh API
  version: '2023-06-01'
  description: >-
    The Latitude.sh API is a RESTful API to manage your Latitude.sh account. It
    allows you to perform the same actions as the Latitude.sh dashboard.
servers:
  - url: https://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
  - url: http://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
security: []
tags:
  - name: API keys
  - name: Billing
  - name: Elastic Ips
  - name: Events
  - name: Firewalls
  - name: IP Addresses
  - name: Kubernetes Clusters
  - name: Operating Systems
  - name: Plans
  - name: Private Networks
  - name: Projects
  - name: Regions
  - name: Roles
  - name: SSH Keys
  - name: Servers
  - name: Storage
  - name: Tags
  - name: Teams
  - name: Team members
  - name: Traffic
  - name: User data
  - name: User profile
  - name: VPN Sessions
  - name: Virtual machines
paths:
  /storage/objects:
    post:
      tags:
        - Storage
      summary: Create object storage
      description: Creates a new object storage bucket for a project.
      operationId: post-storage-objects
      requestBody:
        required: true
        content:
          application/vnd.api+json:
            schema:
              type: object
              required:
                - data
              properties:
                data:
                  type: object
                  required:
                    - type
                    - attributes
                  properties:
                    type:
                      type: string
                      enum:
                        - objects
                    attributes:
                      type: object
                      required:
                        - project
                        - name
                        - region
                      properties:
                        project:
                          type: string
                          description: Project ID or slug
                        name:
                          type: string
                          description: >-
                            Object storage name. Cannot contain special
                            characters or spaces.
                        region:
                          type: string
                          description: Site slug representing the region (e.g., DAL, SAO2)
                        scoped:
                          type: boolean
                          description: >-
                            Whether to create a scoped storage bucket. When
                            true, the bucket is isolated to a specific customer
                            context. Defaults to false.
                          default: false
                        customer:
                          type: string
                          description: >-
                            Customer identifier for scoped storage. Used when
                            `scoped` is true to create customer-specific bucket
                            isolation.
            examples:
              Create:
                summary: Create object storage
                value:
                  data:
                    type: objects
                    attributes:
                      project: proj_6059EqYkOQj8p
                      name: my-bucket
                      region: DAL
              CreateScoped:
                summary: Create scoped object storage
                value:
                  data:
                    type: objects
                    attributes:
                      project: proj_6059EqYkOQj8p
                      name: customer-bucket
                      region: DAL
                      scoped: true
                      customer: acme-corp
      responses:
        '201':
          description: Created
          content:
            application/vnd.api+json:
              examples:
                Created:
                  value:
                    data:
                      id: bucket_6VE1Wd37dXnZJ
                      type: object_storages
                      attributes:
                        name: my-bucket
                        size_in_gb: 0
                        created_at: '2026-03-19T15:30:00.000Z'
                        bucket_name: my-bucket
                        endpoint: https://s3.latitude.sh
                        access_key:
                          - AKIAIOSFODNN7EXAMPLE
                        region:
                          id: DAL
                          city: DAL
                          country: United States
                        project:
                          id: proj_6059EqYkOQj8p
                          name: My Project
                          slug: my-project
                          description: Project description
                          billing_type: Normal
                          billing_method: Normal
                          bandwidth_alert: false
                          environment: null
                          billing:
                            subscription_id: null
                            type: Normal
                            method: Normal
                          stats:
                            databases: 0
                            ip_addresses: 0
                            prefixes: 0
                            servers: 0
                            storages: 1
                            virtual_machines: 0
                            vlans: 0
                        team:
                          id: team_lV9Xe2AAK5CbMgGbpPYLskLRXyV
                          name: My Team
                          slug: my-team
                          description: My Team
                          address: 123 Main St
                          status: verified
                          currency:
                            id: cur_AW6Q2D9lqKLpr
                            code: USD
                            name: US Dollar
                            currency_id: null
              schema:
                type: object
                properties:
                  data:
                    $ref: '#/components/schemas/object_storage_data'
        '403':
          description: Forbidden
          content:
            application/vnd.api+json:
              examples:
                FeatureNotEnabled:
                  value:
                    errors:
                      - code: STORAGE_NOT_ENABLED
                        title: Object Storage not enabled
                        detail: Object Storage is not enabled for this team
                        meta: {}
                        status: '403'
                InsufficientPermissions:
                  value:
                    errors:
                      - code: USER_AUTHORIZATION_ERROR
                        status: forbidden
                        title: User Authorization Error
                        detail: You are not authorized to perform this action.
                        meta: {}
              schema:
                $ref: '#/components/schemas/error_object'
        '404':
          description: Not Found
          content:
            application/vnd.api+json:
              examples:
                InvalidProject:
                  value:
                    errors:
                      - code: INVALID_PROJECT
                        title: Invalid project
                        detail: >-
                          We could not find the project you are trying to create
                          object storage for.
                        meta: {}
                        status: '404'
                InvalidRegion:
                  value:
                    errors:
                      - code: INVALID_REGION
                        title: Invalid region
                        detail: We could not find the region you specified.
                        meta: {}
                        status: '404'
              schema:
                $ref: '#/components/schemas/error_object'
        '409':
          description: Conflict
          content:
            application/vnd.api+json:
              examples:
                AlreadyExists:
                  value:
                    errors:
                      - code: CONFLICT
                        title: Object storage creation error
                        detail: Object Storage already exists
                        meta: {}
                        status: '409'
              schema:
                $ref: '#/components/schemas/error_object'
        '422':
          description: Unprocessable Entity
          content:
            application/vnd.api+json:
              examples:
                ValidationError:
                  value:
                    errors:
                      - code: VALIDATION_ERROR
                        title: Validation Error
                        detail: name cannot contain special chars or spaces
                        meta: {}
                        status: '422'
              schema:
                $ref: '#/components/schemas/error_object'
        '500':
          description: Internal Server Error
          content:
            application/vnd.api+json:
              examples:
                SetupError:
                  value:
                    errors:
                      - code: OBJECT_STORAGE_SETUP_ERROR
                        title: Object storage setup error
                        detail: Failed to provision object storage infrastructure
                        meta: {}
                        status: '500'
              schema:
                $ref: '#/components/schemas/error_object'
      security:
        - Bearer: []
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            import latitudesh_python_sdk
            from latitudesh_python_sdk import Latitudesh
            import os


            with Latitudesh(
                bearer=os.getenv("LATITUDESH_BEARER", ""),
            ) as latitudesh:

                res = latitudesh.storage.post_storage_objects(data={
                    "type": latitudesh_python_sdk.PostStorageObjectsType.OBJECTS,
                    "attributes": {
                        "project": "proj_6059EqYkOQj8p",
                        "name": "my-bucket",
                        "region": "DAL",
                    },
                })

                # Handle response
                print(res)
        - lang: go
          label: Go (SDK)
          source: "package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tlatitudeshgosdk \"github.com/latitudesh/latitudesh-go-sdk\"\n\t\"github.com/latitudesh/latitudesh-go-sdk/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := latitudeshgosdk.New(\n        latitudeshgosdk.WithSecurity(os.Getenv(\"LATITUDESH_BEARER\")),\n    )\n\n    res, err := s.Storage.PostStorageObjects(ctx, operations.PostStorageObjectsRequestBody{\n        Data: operations.PostStorageObjectsData{\n            Type: operations.PostStorageObjectsTypeObjects,\n            Attributes: operations.PostStorageObjectsAttributes{\n                Project: \"proj_6059EqYkOQj8p\",\n                Name: \"my-bucket\",\n                Region: \"DAL\",\n            },\n        },\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.Object != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { Latitudesh } from "latitudesh-typescript-sdk";

            const latitudesh = new Latitudesh({
              bearer: process.env["LATITUDESH_BEARER"] ?? "",
            });

            async function run() {
              const result = await latitudesh.storage.postStorageObjects({
                data: {
                  type: "objects",
                  attributes: {
                    project: "proj_6059EqYkOQj8p",
                    name: "my-bucket",
                    region: "DAL",
                  },
                },
              });

              console.log(result);
            }

            run();
components:
  schemas:
    object_storage_data:
      type: object
      properties:
        id:
          type: string
          description: Object storage ID with bucket_ prefix
        type:
          type: string
          enum:
            - object_storages
        attributes:
          type: object
          properties:
            name:
              type: string
              description: Display name of the object storage
            size_in_gb:
              type: integer
              description: Storage capacity in gigabytes
            created_at:
              type: string
              format: date-time
              nullable: true
              description: Timestamp when the object storage was created
            bucket_name:
              type: string
              description: S3-compatible bucket name
            endpoint:
              type: string
              description: S3-compatible endpoint URL for accessing the bucket
            access_key:
              type: array
              items:
                type: string
              description: S3 access key(s) for authentication
            region:
              type: object
              nullable: true
              description: Region information where the object storage is located
              properties:
                id:
                  type: string
                  description: Region identifier
                city:
                  type: string
                  description: City identifier
                country:
                  type: string
                  nullable: true
                  description: Country name
            project:
              $ref: '#/components/schemas/project_include'
            team:
              $ref: '#/components/schemas/team_include'
    error_object:
      type: object
      properties:
        errors:
          type: array
          items:
            type: object
            properties:
              code:
                type: string
                nullable: true
              status:
                type: string
              title:
                type: string
              detail:
                type: string
              source:
                type: object
                properties:
                  pointer:
                    type: string
                  parameter:
                    type: string
              meta:
                type: object
    project_include:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        slug:
          type: string
        description:
          type: string
          nullable: true
        billing_type:
          type: string
          nullable: true
        provisioning_type:
          type: string
          nullable: true
        billing_method:
          type: string
          nullable: true
        bandwidth_alert:
          type: boolean
        environment:
          type: string
          nullable: true
        billing:
          type: object
          properties:
            subscription_id:
              type: string
              nullable: true
            type:
              type: string
            method:
              type: string
        stats:
          type: object
          properties:
            ip_addresses:
              type: integer
            prefixes:
              type: integer
            servers:
              type: integer
            vlans:
              type: integer
    team_include:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        slug:
          type: string
        description:
          type: string
          nullable: true
        address:
          type: string
        currency:
          type: object
        status:
          type: string
        feature_flags:
          type: array
          items:
            type: string
  securitySchemes:
    Bearer:
      type: apiKey
      name: Authorization
      in: header

````